#line 2 "imp_vrml_v1.c"

#line 4 "imp_vrml_v1.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* An opaque pointer. */
#ifndef YY_TYPEDEF_YY_SCANNER_T
#define YY_TYPEDEF_YY_SCANNER_T
typedef void* yyscan_t;
#endif

/* For convenience, these vars (plus the bison vars far below)
   are macros in the reentrant scanner. */
#define yyin yyg->yyin_r
#define yyout yyg->yyout_r
#define yyextra yyg->yyextra_r
#define yyleng yyg->yyleng_r
#define yytext yyg->yytext_r
#define yylineno (YY_CURRENT_BUFFER_LVALUE->yy_bs_lineno)
#define yycolumn (YY_CURRENT_BUFFER_LVALUE->yy_bs_column)
#define yy_flex_debug yyg->yy_flex_debug_r

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yyg->yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yyg->yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE vrml_v1_yyrestart(yyin ,yyscanner )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE 16384
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = yyg->yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yyg->yy_c_buf_p = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yyg->yytext_ptr , yyscanner )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via vrml_v1_yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( yyg->yy_buffer_stack \
                          ? yyg->yy_buffer_stack[yyg->yy_buffer_stack_top] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE yyg->yy_buffer_stack[yyg->yy_buffer_stack_top]

void vrml_v1_yyrestart (FILE *input_file ,yyscan_t yyscanner );
void vrml_v1_yy_switch_to_buffer (YY_BUFFER_STATE new_buffer ,yyscan_t yyscanner );
YY_BUFFER_STATE vrml_v1_yy_create_buffer (FILE *file,int size ,yyscan_t yyscanner );
void vrml_v1_yy_delete_buffer (YY_BUFFER_STATE b ,yyscan_t yyscanner );
void vrml_v1_yy_flush_buffer (YY_BUFFER_STATE b ,yyscan_t yyscanner );
void vrml_v1_yypush_buffer_state (YY_BUFFER_STATE new_buffer ,yyscan_t yyscanner );
void vrml_v1_yypop_buffer_state (yyscan_t yyscanner );

static void vrml_v1_yyensure_buffer_stack (yyscan_t yyscanner );
static void vrml_v1_yy_load_buffer_state (yyscan_t yyscanner );
static void vrml_v1_yy_init_buffer (YY_BUFFER_STATE b,FILE *file ,yyscan_t yyscanner );

#define YY_FLUSH_BUFFER vrml_v1_yy_flush_buffer(YY_CURRENT_BUFFER ,yyscanner)

YY_BUFFER_STATE vrml_v1_yy_scan_buffer (char *base,yy_size_t size ,yyscan_t yyscanner );
YY_BUFFER_STATE vrml_v1_yy_scan_string (yyconst char *yy_str ,yyscan_t yyscanner );
YY_BUFFER_STATE vrml_v1_yy_scan_bytes (yyconst char *bytes,int len ,yyscan_t yyscanner );

void *vrml_v1_yyalloc (yy_size_t ,yyscan_t yyscanner );
void *vrml_v1_yyrealloc (void *,yy_size_t ,yyscan_t yyscanner );
void vrml_v1_yyfree (void * ,yyscan_t yyscanner );

#define yy_new_buffer vrml_v1_yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        vrml_v1_yyensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            vrml_v1_yy_create_buffer(yyin,YY_BUF_SIZE ,yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        vrml_v1_yyensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            vrml_v1_yy_create_buffer(yyin,YY_BUF_SIZE ,yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

typedef unsigned char YY_CHAR;

typedef int yy_state_type;

#define yytext_ptr yytext_r

static yy_state_type yy_get_previous_state (yyscan_t yyscanner );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  ,yyscan_t yyscanner);
static int yy_get_next_buffer (yyscan_t yyscanner );
static void yy_fatal_error (yyconst char msg[] ,yyscan_t yyscanner );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yyg->yytext_ptr = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	yyg->yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yyg->yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 32
#define YY_END_OF_BUFFER 33
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_acclist[299] =
    {   0,
       33,   30,   32,   31,   32,   30,   32,   15,   30,   32,
       30,   32,16411,   30,   32,16411,   30,   32,16411,   30,
       32,16411,   30,   32,16411,   30,   32,16411,   26,   30,
       32,   30,   32,   30,   32,   30,   32,   30,   32,   30,
       32,   30,   32,   30,   32,   30,   32,   28,   30,   32,
       29,   30,   32,    1,   30,   32,   30,   32,    4,   30,
       32,    5,   31,   32,    4,   30,   32,    4,   15,   30,
       32,    4,   30,   32,16411,    4,   30,   32,16411,    4,
       30,   32,16411,    4,   30,   32,16411,    4,   30,   32,
    16411,    4,   30,   32,16411,    4,   30,   32,16411,    4,

       26,   30,   32,    4,   30,   32,    4,   30,   32,    4,
       30,   32,    4,   30,   32,    4,   30,   32,    4,   30,
       32,    4,   30,   32,    4,   30,   32,    4,   28,   30,
       32,    4,   29,   30,   32,    6,   30,   32,    7,   31,
       32,    6,   30,   32,    6,   15,   30,   32,    6,   30,
       32,16411,    6,   30,   32,16411,    6,   30,   32,16411,
        6,   30,   32,16411,    6,   30,   32,16411,    6,   30,
       32,16411,    6,   26,   30,   32,    6,   30,   32,    6,
       30,   32,    6,   30,   32,    6,   30,   32,    6,   30,
       32,    6,   30,   32,    6,   30,   32,    6,   30,   32,

        6,   28,   30,   32,    6,   29,   30,   32,   15,   15,
       15,   14,   15,16411, 8219,16411,16411,16411,16411,16411,
        1,    3,    3,16411,16411,16411,16411,16411,16411,16411,
    16411,16411,16411,16411,16411,16411,16411,16411,16411,16411,
    16411,16411,    9, 8219,16411,16411,16411,16411,   25,   22,
    16411,    9,16411,16411,16411,16411,    2,16411,16411,16411,
    16411,16411,16411,16411,   10, 8219,16411,16411,16411,16411,
    16411,    8, 8219,   20,16411,16411,16411,   23,   12, 8219,
    16411,16411,16411,16411,   16,   17,   21,16411,16411,   19,
       24,   18,   13, 8219,16411,   11, 8219,   11

    } ;

static yyconst flex_int16_t yy_accept[276] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    2,    4,    6,
        8,   11,   14,   17,   20,   23,   26,   29,   32,   34,
       36,   38,   40,   42,   44,   46,   48,   51,   54,   57,
       59,   62,   65,   68,   72,   76,   80,   84,   88,   92,
       96,  100,  104,  107,  110,  113,  116,  119,  122,  125,
      128,  132,  136,  139,  142,  145,  149,  153,  157,  161,
      165,  169,  173,  177,  180,  183,  186,  189,  192,  195,
      198,  201,  205,  209,  210,  211,  212,  213,  214,  214,
      214,  215,  216,  217,  218,  219,  220,  221,  221,  221,
      221,  221,  221,  221,  221,  221,  221,  221,  222,  222,

      223,  225,  226,  227,  228,  229,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  231,  232,  233,
      234,  235,  236,  236,  236,  236,  236,  236,  236,  236,
      236,  236,  236,  236,  237,  238,  239,  240,  241,  242,
      242,  242,  242,  242,  242,  242,  242,  242,  242,  242,
      242,  243,  243,  243,  245,  246,  247,  248,  249,  249,
      249,  249,  249,  249,  250,  250,  251,  251,  251,  251,
      251,  252,  253,  254,  255,  256,  257,  257,  257,  257,
      257,  257,  257,  257,  257,  258,  259,  260,  261,  262,
      263,  263,  263,  263,  263,  263,  263,  263,  263,  264,

      265,  265,  267,  268,  269,  269,  269,  269,  269,  269,
      269,  269,  269,  270,  271,  272,  272,  274,  274,  274,
      274,  274,  274,  274,  275,  275,  275,  276,  277,  278,
      278,  278,  279,  279,  279,  279,  279,  279,  279,  281,
      282,  283,  283,  283,  283,  283,  283,  283,  284,  285,
      285,  286,  286,  287,  287,  287,  287,  287,  288,  289,
      290,  290,  291,  291,  292,  292,  293,  293,  295,  296,
      296,  296,  298,  299,  299
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        2,    2,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    1,    1,    5,    1,    1,    1,    1,    1,
        1,    1,    1,    6,    7,    8,    1,    9,    9,    9,
       10,    9,    9,    9,    9,    9,    9,    1,    1,    1,
        1,    1,    1,    1,   11,   11,   12,   11,   11,   13,
       14,   11,   15,   11,   11,   16,   17,   11,   11,   11,
       11,   18,   19,   20,   11,   21,   11,   11,   11,   11,
       22,    1,   23,    1,    1,    1,   24,   25,   26,   27,

       28,   29,   30,   31,   32,   30,   30,   33,   34,   35,
       36,   37,   30,   38,   39,   40,   41,   42,   30,   43,
       44,   30,   45,    1,   46,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[47] =
    {   0,
        1,    2,    2,    3,    1,    4,    5,    5,    3,    3,
        6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
        6,    1,    4,    6,    6,    6,    6,    7,    6,    6,
        6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
        6,    6,    6,    6,    6,    1
    } ;

static yyconst flex_int16_t yy_base[278] =
    {   0,
        0,   42,   81,    0,  127,    0,  619,  620,  620,   39,
      172,  173,  179,  181,  182,  180,  183,  620,  584,  581,
      584,  581,  590,  577,   19,  574,  620,  620,  590,  183,
      620,  620,   42,    0,  185,  187,  193,  194,  188,  206,
      197,  620,  576,  573,  576,  573,  582,  569,   22,  566,
      620,  620,  620,  620,   45,    0,  190,  204,  198,  209,
      192,  217,  620,  569,  566,  569,  566,  575,  562,   26,
      559,  620,  620,    0,    0,   51,  620,    0,   52,  205,
      237,  620,  242,  243,  244,  251,  248,  571,  559,  565,
      561,  552,  559,  558,  561,  564,  568,  620,  251,   56,

      249,  257,  256,  264,  270,  259,  549,  538,  546,  533,
       34,  536,  534,  542,  531,  548,  272,  266,  262,  268,
      280,  276,  536,  536,  521,  522,  522,  527,  518,  525,
      515,  516,  538,  296,  316,  282,  312,  319,  318,  518,
      537,  512,  518,  517,  505,  327,  512,  513,  508,  540,
      320,  330,  333,  620,  339,  322,  334,  336,  503,  507,
      512,  497,  513,  620,  348,  620,  508,  510,  509,  492,
      335,  620,  343,  341,  344,  349,  500,  482,  495,  476,
      470,  462,  459,  437,  620,  356,  367,  354,  368,  364,
      436,  439,  428,  435,  422,  390,  269,  249,  365,  369,

      373,  620,  386,  379,  242,  230,  236,  231,  230,  401,
      228,  168,  396,  383,  393,  394,  620,  163,  413,  157,
      157,   53,  423,  620,   46,   52,  403,  415,  404,   39,
      440,  620,   38,   38,   45,   35,   26,  416,  620,  418,
      432,  448,  451,   31,   25,   29,  454,  426,  436,  476,
      620,  480,  620,  483,  486,  489,  492,  620,  455,  465,
      513,  620,  516,  620,  519,  620,  461,  620,  522,  525,
      528,  620,  620,  620,  571,  577,  580
    } ;

static yyconst flex_int16_t yy_def[278] =
    {   0,
      274,    1,  274,    3,  274,    5,  274,  274,  274,  274,
      274,  275,  275,  275,  275,  275,  275,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,   11,  275,  275,  275,  275,  275,  275,
      275,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,   11,  275,  275,  275,  275,
      275,  275,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,   11,  276,   11,  274,   11,  277,  274,
      275,  274,  275,  275,  275,  275,  275,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,

      275,  275,  275,  275,  275,  275,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  275,  275,  275,  275,
      275,  275,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  275,  275,  275,  275,  275,  275,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      275,  274,  274,  274,  275,  275,  275,  275,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      275,  274,  275,  275,  275,  275,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  275,  275,  275,  275,  275,
      274,  274,  274,  274,  274,  274,  274,  274,  275,  275,

      274,  274,  275,  275,  274,  274,  274,  274,  274,  274,
      274,  274,  275,  275,  275,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  275,  275,  275,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  275,
      275,  274,  274,  274,  274,  274,  274,  275,  275,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  275,  275,
      274,  274,  274,  274,  274,  274,  274,  274,  275,  274,
      274,  274,  274,    0,  274,  274,  274
    } ;

static yyconst flex_int16_t yy_nxt[667] =
    {   0,
        8,    8,    9,    8,    8,    8,   10,    8,   11,   11,
       12,   13,   12,   14,   15,   12,   16,   12,   17,   12,
       12,    8,   18,   19,    8,   20,   21,   22,    8,    8,
        8,    8,    8,   23,    8,    8,   24,    8,   25,   26,
        8,    8,    8,    8,   27,   28,   29,   74,   74,   94,
       74,   74,   94,   74,   74,   95,   94,   77,   95,   76,
       76,  127,   95,  100,  100,  100,  256,  255,  254,  247,
      246,  128,  245,  244,   77,  243,  242,  237,  236,  235,
       30,   31,   31,   32,   31,   31,   31,   33,   31,   34,
       34,   35,   36,   35,   37,   38,   35,   39,   35,   40,

       35,   41,   31,   42,   43,   31,   44,   45,   46,   31,
       31,   31,   31,   31,   47,   31,   31,   48,   31,   49,
       50,   31,   31,   31,   31,   51,   52,   53,   53,   54,
       53,   53,   53,   55,   53,   56,   56,   57,   58,   57,
       59,   60,   57,   61,   57,   62,   57,   57,   53,   63,
       64,   53,   65,   66,   67,   53,   53,   53,   53,   53,
       68,   53,   53,   69,   53,   70,   71,   53,   53,   53,
       53,   72,   73,   75,   75,   76,   80,   77,   76,   76,
       78,   78,   80,   80,   80,   80,   80,   98,   80,  234,
       80,   80,  233,   80,   77,   80,   80,   80,  230,   79,

       80,   80,  226,   86,  100,  101,  101,   80,   80,   80,
       87,   86,   80,   94,   83,   86,   85,   82,   84,   95,
       80,   99,   83,   82,   82,   82,   82,   82,   85,   82,
       84,   82,   82,   87,   82,   84,   82,   82,   82,   83,
       80,   82,   82,   85,   87,   80,   80,   80,   82,   82,
       82,   80,   80,   82,   80,   98,  100,  101,  101,   80,
       80,   82,   80,  225,  222,   80,  221,   80,  220,   80,
      104,   80,  219,   80,  218,   80,  212,  102,  103,   80,
      211,   82,  122,   80,  106,   80,   82,   82,   82,   99,
      105,  119,   82,   82,  117,   82,  118,  120,  134,   80,

       82,   82,  135,   82,  136,  137,   82,  121,   82,  155,
       82,  138,   82,  139,   82,   80,   82,  152,  152,  153,
       82,   80,   80,   80,   82,   80,   82,  151,  165,  165,
      165,  152,  152,  152,  152,  152,  153,   80,   80,   80,
       82,  158,   80,  156,   80,  174,   80,   80,  166,  165,
      165,  165,   80,  175,  171,  187,   82,  201,  186,   80,
      154,  157,   82,   82,   82,  173,   82,   80,   80,  166,
       80,   80,   80,  188,  172,  176,  201,  154,   82,   82,
       82,  189,  216,   82,  190,   82,   80,   82,   82,   80,
      200,  203,  213,   82,  214,  199,   80,  216,  202,   80,

       82,  204,  223,  223,  223,  227,  238,   80,   82,   82,
      228,   82,   82,   82,  231,  231,  231,  202,   80,  238,
      215,   80,  224,  217,  223,  223,  223,   82,  210,   80,
       82,  229,  241,  240,  232,   80,  209,   82,  217,   80,
       82,  231,  231,  231,  224,  248,  208,  239,   82,  250,
      250,  250,  252,  252,  252,  257,  257,  257,  267,   82,
      239,  232,   82,  207,  267,  259,  206,  249,   80,  251,
       82,  205,  253,  260,  198,  258,   82,  250,  250,  250,
       82,  252,  252,  252,  261,  261,  261,  263,  263,  263,
      265,  265,  265,  257,  257,  257,  197,  251,  269,  268,

      196,  253,  195,  194,  262,  268,  193,  264,  192,   82,
      266,  191,  185,  258,  261,  261,  261,  263,  263,  263,
      265,  265,  265,  270,  270,  271,  270,  270,  270,  270,
      270,  271,  184,  183,  262,  182,  181,  264,  180,  179,
      266,  178,  177,  170,  169,  168,  167,  164,  163,  162,
      161,  160,  159,  150,  149,  148,  147,  146,  145,  144,
      143,  142,  141,  140,  133,  132,  272,  131,  130,  273,
      129,  126,  272,   81,  125,  124,   81,   81,   75,   75,
      123,   75,   79,   79,   79,  116,   79,  115,  114,  113,
      112,  111,  110,  109,  108,  107,   96,   93,   92,   91,

       90,   89,   88,   96,   93,   92,   91,   90,   89,   88,
       97,   96,   93,   92,   91,   90,   89,   88,  274,    7,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274
    } ;

static yyconst flex_int16_t yy_chk[667] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    2,   10,   10,   25,
       33,   33,   49,   55,   55,   25,   70,   79,   49,   76,
       76,  111,   70,  100,  100,  100,  246,  245,  244,  237,
      236,  111,  235,  234,   79,  233,  230,  226,  225,  222,
        2,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,   11,   11,   11,   12,   11,   11,   11,
       11,   11,   13,   16,   14,   15,   17,   30,   35,  221,
       36,   39,  220,   57,   11,   61,   37,   38,  218,   11,

       41,   59,  212,   16,   41,   41,   41,   58,   80,   40,
       17,   39,   60,   30,   13,   61,   15,   12,   14,   30,
       62,   30,   36,   13,   16,   14,   15,   17,   38,   35,
       37,   36,   39,   40,   57,   59,   61,   37,   38,   58,
       81,   41,   59,   60,   62,   83,   84,   85,   58,   80,
       40,   87,  101,   60,   86,   99,  101,  101,  101,  103,
      102,   62,  106,  211,  209,  119,  208,  104,  207,  118,
       85,  120,  206,  105,  205,  117,  198,   83,   84,  122,
      197,   81,  106,  121,   87,  136,   83,   84,   85,   99,
       86,  104,   87,  101,  102,   86,  103,  105,  117,  134,

      103,  102,  118,  106,  119,  120,  119,  105,  104,  136,
      118,  121,  120,  122,  105,  137,  117,  135,  135,  135,
      122,  139,  138,  151,  121,  156,  136,  134,  146,  146,
      146,  152,  152,  152,  153,  153,  153,  157,  171,  158,
      134,  139,  155,  137,  174,  156,  173,  175,  146,  165,
      165,  165,  176,  157,  151,  173,  137,  188,  171,  186,
      135,  138,  139,  138,  151,  155,  156,  190,  199,  165,
      187,  189,  200,  174,  152,  158,  201,  153,  157,  171,
      158,  175,  204,  155,  176,  174,  214,  173,  175,  203,
      187,  189,  199,  176,  200,  186,  215,  216,  188,  213,

      186,  190,  210,  210,  210,  213,  227,  229,  190,  199,
      214,  187,  189,  200,  219,  219,  219,  201,  228,  238,
      203,  240,  210,  204,  223,  223,  223,  214,  196,  248,
      203,  215,  229,  228,  219,  241,  195,  215,  216,  249,
      213,  231,  231,  231,  223,  240,  194,  227,  229,  242,
      242,  242,  243,  243,  243,  247,  247,  247,  259,  228,
      238,  231,  240,  193,  267,  248,  192,  241,  260,  242,
      248,  191,  243,  249,  184,  247,  241,  250,  250,  250,
      249,  252,  252,  252,  254,  254,  254,  255,  255,  255,
      256,  256,  256,  257,  257,  257,  183,  250,  260,  259,

      182,  252,  181,  180,  254,  267,  179,  255,  178,  260,
      256,  177,  170,  257,  261,  261,  261,  263,  263,  263,
      265,  265,  265,  269,  269,  269,  270,  270,  270,  271,
      271,  271,  169,  168,  261,  167,  163,  263,  162,  161,
      265,  160,  159,  150,  149,  148,  147,  145,  144,  143,
      142,  141,  140,  133,  132,  131,  130,  129,  128,  127,
      126,  125,  124,  123,  116,  115,  269,  114,  113,  270,
      112,  110,  271,  275,  109,  108,  275,  275,  276,  276,
      107,  276,  277,  277,  277,   97,  277,   96,   95,   94,
       93,   92,   91,   90,   89,   88,   71,   69,   68,   67,

       66,   65,   64,   50,   48,   47,   46,   45,   44,   43,
       29,   26,   24,   23,   22,   21,   20,   19,    7,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274
    } ;

#define YY_TRAILING_MASK 0x2000
#define YY_TRAILING_HEAD_MASK 0x4000
#define REJECT \
{ \
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */ \
yy_cp = yyg->yy_full_match; /* restore poss. backed-over text */ \
yyg->yy_lp = yyg->yy_full_lp; /* restore orig. accepting pos. */ \
yyg->yy_state_ptr = yyg->yy_full_state; /* restore orig. state */ \
yy_current_state = *yyg->yy_state_ptr; /* restore curr. state */ \
++yyg->yy_lp; \
goto find_rule; \
}

#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
#line 1 "imp_vrml_v1.l"
/* $Id$ */
/*
    libg3d - 3D object loading library

    Copyright (C) 2005-2009  Markus Dahms <mad@automagically.de>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/* $Id$ */
/*
libg3d - 3D object loading library
Copyright (C) 2005-2009  Markus Dahms <mad@automagically.de>
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#define __USE_POSIX 1
#define _XOPEN_SOURCE 500
#define _POSIX_C_SOURCE 200112L
#include <stdio.h>
#include <string.h>
#include <locale.h>
#include <g3d/types.h>
#include <g3d/material.h>
#include <g3d/vector.h>
#if DEBUG > 0
#	define vrml_dump_hier(level, section) g_debug("\\%.*s[%s]", \
level, "               ", section)
#else
#	define vrml_dump_hier(level, section) /* */
#endif
#define VRML_OTYPE_MAT                             0x0100
#define VRML_OTYPE_MAT_AMBIENTCOLOR                0x0101
#define VRML_OTYPE_MAT_DIFFUSECOLOR                0x0102
#define VRML_OTYPE_MAT_SPECULARCOLOR               0x0103
#define VRML_OTYPE_MAT_EMISSIVECOLOR               0x0104
#define VRML_OTYPE_MAT_SHININESS                   0x0105
#define VRML_OTYPE_MAT_TRANSPARENCY                0x0106
#define VRML_OTYPE_COORD3                          0x0200
#define VRML_OTYPE_COORD3_POINT                    0x0201
#define VRML_OTYPE_IDXFACESET                      0x0300
#define VRML_OTYPE_IDXFACESET_COORDIDX             0x0301
#define VRML_OTYPE_IDXFACESET_MATIDX               0x0302
#define VRML_OTYPE_MTRANS                          0x0400
#define VRML_OTYPE_MTRANS_MATRIX                   0x0401
#line 778 "imp_vrml_v1.c"

#define INITIAL 0
#define VRMLHEADER 1
#define COMMENT 2

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* Holds the entire state of the reentrant scanner. */
struct yyguts_t
    {

    /* User-defined. Not touched by flex. */
    YY_EXTRA_TYPE yyextra_r;

    /* The rest are the same as the globals declared in the non-reentrant scanner. */
    FILE *yyin_r, *yyout_r;
    size_t yy_buffer_stack_top; /**< index of top of stack. */
    size_t yy_buffer_stack_max; /**< capacity of stack. */
    YY_BUFFER_STATE * yy_buffer_stack; /**< Stack as an array. */
    char yy_hold_char;
    int yy_n_chars;
    int yyleng_r;
    char *yy_c_buf_p;
    int yy_init;
    int yy_start;
    int yy_did_buffer_switch_on_eof;
    int yy_start_stack_ptr;
    int yy_start_stack_depth;
    int *yy_start_stack;
    yy_state_type yy_last_accepting_state;
    char* yy_last_accepting_cpos;

    int yylineno_r;
    int yy_flex_debug_r;

    yy_state_type *yy_state_buf;
    yy_state_type *yy_state_ptr;
    char *yy_full_match;
    int yy_lp;

    /* These are only needed for trailing context rules,
     * but there's no conditional variable for that yet. */
    int yy_looking_for_trail_begin;
    int yy_full_lp;
    int *yy_full_state;

    char *yytext_r;
    int yy_more_flag;
    int yy_more_len;

    }; /* end struct yyguts_t */

static int yy_init_globals (yyscan_t yyscanner );

int vrml_v1_yylex_init (yyscan_t* scanner);

int vrml_v1_yylex_init_extra (YY_EXTRA_TYPE user_defined,yyscan_t* scanner);

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int vrml_v1_yylex_destroy (yyscan_t yyscanner );

int vrml_v1_yyget_debug (yyscan_t yyscanner );

void vrml_v1_yyset_debug (int debug_flag ,yyscan_t yyscanner );

YY_EXTRA_TYPE vrml_v1_yyget_extra (yyscan_t yyscanner );

void vrml_v1_yyset_extra (YY_EXTRA_TYPE user_defined ,yyscan_t yyscanner );

FILE *vrml_v1_yyget_in (yyscan_t yyscanner );

void vrml_v1_yyset_in  (FILE * in_str ,yyscan_t yyscanner );

FILE *vrml_v1_yyget_out (yyscan_t yyscanner );

void vrml_v1_yyset_out  (FILE * out_str ,yyscan_t yyscanner );

int vrml_v1_yyget_leng (yyscan_t yyscanner );

char *vrml_v1_yyget_text (yyscan_t yyscanner );

int vrml_v1_yyget_lineno (yyscan_t yyscanner );

void vrml_v1_yyset_lineno (int line_number ,yyscan_t yyscanner );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int vrml_v1_yywrap (yyscan_t yyscanner );
#else
extern int vrml_v1_yywrap (yyscan_t yyscanner );
#endif
#endif

    static void yyunput (int c,char *buf_ptr  ,yyscan_t yyscanner);
    
#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int ,yyscan_t yyscanner);
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * ,yyscan_t yyscanner);
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (yyscan_t yyscanner );
#else
static int input (yyscan_t yyscanner );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg , yyscanner)
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int vrml_v1_yylex (yyscan_t yyscanner);

#define YY_DECL int vrml_v1_yylex (yyscan_t yyscanner)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

#line 86 "imp_vrml_v1.l"

	G3DObject *object = NULL;
	G3DFace *face;
	G3DMaterial *material = NULL;
	guint32 level = 0, off, otype = 0, sep_level = 0;
	guint32 ohasmtrx = 0;
	guint32 faceidx = 0, faceidxbuf[128];
	guint32 matidx = 0;
	gint32 tmps32, i;
	gfloat matrix[16];

#line 1027 "imp_vrml_v1.c"

	if ( !yyg->yy_init )
		{
		yyg->yy_init = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

        /* Create the reject buffer large enough to save one state per allowed character. */
        if ( ! yyg->yy_state_buf )
            yyg->yy_state_buf = (yy_state_type *)vrml_v1_yyalloc(YY_STATE_BUF_SIZE  ,yyscanner);
            if ( ! yyg->yy_state_buf )
                YY_FATAL_ERROR( "out of dynamic memory in vrml_v1_yylex()" );

		if ( ! yyg->yy_start )
			yyg->yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			vrml_v1_yyensure_buffer_stack (yyscanner);
			YY_CURRENT_BUFFER_LVALUE =
				vrml_v1_yy_create_buffer(yyin,YY_BUF_SIZE ,yyscanner);
		}

		vrml_v1_yy_load_buffer_state(yyscanner );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yyg->yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yyg->yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yyg->yy_start;
		yy_current_state += YY_AT_BOL();

		yyg->yy_state_ptr = yyg->yy_state_buf;
		*yyg->yy_state_ptr++ = yy_current_state;

yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 275 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			*yyg->yy_state_ptr++ = yy_current_state;
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 620 );

yy_find_action:
		yy_current_state = *--yyg->yy_state_ptr;
		yyg->yy_lp = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( yyg->yy_lp && yyg->yy_lp < yy_accept[yy_current_state + 1] )
				{
				yy_act = yy_acclist[yyg->yy_lp];
				if ( yy_act & YY_TRAILING_HEAD_MASK ||
				     yyg->yy_looking_for_trail_begin )
					{
					if ( yy_act == yyg->yy_looking_for_trail_begin )
						{
						yyg->yy_looking_for_trail_begin = 0;
						yy_act &= ~YY_TRAILING_HEAD_MASK;
						break;
						}
					}
				else if ( yy_act & YY_TRAILING_MASK )
					{
					yyg->yy_looking_for_trail_begin = yy_act & ~YY_TRAILING_MASK;
					yyg->yy_looking_for_trail_begin |= YY_TRAILING_HEAD_MASK;
					}
				else
					{
					yyg->yy_full_match = yy_cp;
					yyg->yy_full_state = yyg->yy_state_ptr;
					yyg->yy_full_lp = yyg->yy_lp;
					break;
					}
				++yyg->yy_lp;
				goto find_rule;
				}
			--yy_cp;
			yy_current_state = *--yyg->yy_state_ptr;
			yyg->yy_lp = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
case 1:
YY_RULE_SETUP
#line 97 "imp_vrml_v1.l"
{
	BEGIN COMMENT;
}
	YY_BREAK
case 2:
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 5;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 101 "imp_vrml_v1.l"
{
	/* magic header */
	#if DEBUG > 0
	g_debug("VRML: got header");
	#endif
	BEGIN VRMLHEADER;
}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 109 "imp_vrml_v1.l"
{
	#if DEBUG > 0
	g_debug("VRML: version %s", yytext + 1);
	#endif
}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 115 "imp_vrml_v1.l"
/* */
	YY_BREAK
case 5:
/* rule 5 can match eol */
YY_RULE_SETUP
#line 117 "imp_vrml_v1.l"
{
	BEGIN INITIAL;
}
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 121 "imp_vrml_v1.l"
{
	#if DEBUG > 0
	g_debug("COMMENT: %s", yytext);
	#endif
}
	YY_BREAK
case 7:
/* rule 7 can match eol */
YY_RULE_SETUP
#line 127 "imp_vrml_v1.l"
{
	BEGIN INITIAL;
}
	YY_BREAK
case 8:
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 9;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 131 "imp_vrml_v1.l"
{
	vrml_dump_hier(level, "Separator");
	if((object == NULL) || (object->vertex_count == 0))
	{
		object = g_new0(G3DObject, 1);
		((G3DModel *)yyextra)->objects = g_slist_append(
			((G3DModel *)yyextra)->objects, object);
		sep_level = level;
		ohasmtrx = 0;
	}
}
	YY_BREAK
case 9:
/* rule 9 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 5;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 143 "imp_vrml_v1.l"
{
	vrml_dump_hier(level, "Group");
}
	YY_BREAK
case 10:
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 8;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 147 "imp_vrml_v1.l"
{
	vrml_dump_hier(level, "Material");
	if(object)
	{
		material = g3d_material_new();
		material->name = g_strdup("object material");
		object->materials = g_slist_append(object->materials, material);
	}
	otype = VRML_OTYPE_MAT;
}
	YY_BREAK
case 11:
/* rule 11 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 15;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 158 "imp_vrml_v1.l"
{
	vrml_dump_hier(level, "MatrixTransform");
	otype = VRML_OTYPE_MTRANS;
}
	YY_BREAK
case 12:
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 11;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 163 "imp_vrml_v1.l"
{
	vrml_dump_hier(level, "Coordinate3");
	if(!object)
	{
		object = g_new0(G3DObject, 1);
		object->name = g_strdup("VRML 1 object");
		((G3DModel *)yyextra)->objects = g_slist_append(
			((G3DModel *)yyextra)->objects, object);
		ohasmtrx = 0;
	}
	otype = VRML_OTYPE_COORD3;
}
	YY_BREAK
case 13:
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 14;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 176 "imp_vrml_v1.l"
{
	vrml_dump_hier(level, "IndexedFaceSet");
	otype = VRML_OTYPE_IDXFACESET;
}
	YY_BREAK
case 14:
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 181 "imp_vrml_v1.l"
{
	#if DEBUG > 3
	g_debug("# (0x%04x) %s", otype, yytext);
	#endif
	if((otype & 0xFF00) == VRML_OTYPE_MAT)
	{
		if(object == NULL) continue;
		material = g_slist_nth_data(object->materials, matidx);
		if(material == NULL)
		{
			material = g3d_material_new();
			material->name = g_strdup_printf("material #%d", matidx);
			object->materials = g_slist_append(object->materials, material);
		}
		matidx ++;
		switch(otype)
		{
			case VRML_OTYPE_MAT_DIFFUSECOLOR:
				if(sscanf(yytext, "%f%f%f",
					&(material->r), &(material->g), &(material->b)) != 3)
				{
		#if DEBUG > 0
					g_debug("VRML1: failed to get ambient color");
		#endif
				}
				break;

			default:
	#if DEBUG > 0
				g_debug("VRML: unhandled material property: 0x%02x (%s)",
					otype, yytext);
	#endif
				break;
		}
	}
	else if(otype == VRML_OTYPE_COORD3_POINT)
	{
		off = object->vertex_count;
		object->vertex_count ++;
		object->vertex_data = g_realloc(object->vertex_data,
			object->vertex_count * 3 * sizeof(gfloat));

	#if DEBUG > 3
		g_debug("VRML: object vertex count: %d", object->vertex_count);
	#endif

		if(sscanf(yytext, "%f%f%f",
			&(object->vertex_data[off * 3 + 0]),
			&(object->vertex_data[off * 3 + 1]),
			&(object->vertex_data[off * 3 + 2])) != 3)
		{
			g_warning("VRML: failed to read vertex (%s)\n", yytext);
		}
		else
		{
	#if DEBUG > 3
			if((object->vertex_data[off * 3 + 0] == 0.0) ||
				(object->vertex_data[off * 3 + 1] == 0.0) ||
				(object->vertex_data[off * 3 + 2] == 0.0))
			{
				g_debug("VRML1: 0.0: %+2.2f %+2.2f %+2.2f (%s)",
					object->vertex_data[off * 3 + 0],
					object->vertex_data[off * 3 + 1],
					object->vertex_data[off * 3 + 2],
					yytext);
			}
	#endif
			if(ohasmtrx)
				g3d_vector_transform(
					&(object->vertex_data[off * 3 + 0]),
					&(object->vertex_data[off * 3 + 1]),
					&(object->vertex_data[off * 3 + 2]),
					matrix);
		}
	}
	else if(otype == VRML_OTYPE_IDXFACESET_COORDIDX)
	{
		sscanf(yytext, "%i", &tmps32);
		if(tmps32 == -1)
		{
			if(object == NULL) continue;

			face = g_new0(G3DFace, 1);
			face->material = material;
			if(face->material == NULL)
				face->material = g_slist_nth_data(
					object->materials, 0);
			if(face->material == NULL)
				face->material = g_slist_nth_data(
					((G3DModel *)yyextra)->materials, 0);
			face->vertex_count = faceidx;
			face->vertex_indices = g_new0(guint32, face->vertex_count);
			for(i = 0; i < face->vertex_count; i ++)
			{
				if(faceidxbuf[i] >= object->vertex_count)
				{
					g_debug("VRML: Face: index %d >= vertex count (%d)",
						faceidxbuf[i], object->vertex_count);
				}
				else
				{
					face->vertex_indices[i] = faceidxbuf[i];
				}
			}

			if(face->vertex_count >= 3)
				object->faces = g_slist_prepend(object->faces, face);
			faceidx = 0;
		}
		else
		{
	#if DEBUG > 3
			if(tmps32 == 0)
				g_debug("VRML1: faceidx 0: %s", yytext);
	#endif
			faceidxbuf[faceidx] = tmps32;
			faceidx ++;
		}
	}
	else if(otype == VRML_OTYPE_IDXFACESET_MATIDX)
	{
		i = atoi(yytext);
	#if DEBUG > 3
		g_debug("VRML1: looking for object material #%d", i);
	#endif
		material = g_slist_nth_data(object->materials, i);
		if(material)
		{
	#if DEBUG > 3
			g_debug("VRML1: got material to update");
	#endif
			face = g_slist_nth_data(object->faces, faceidx);
			if(face)
			{
				face->material = material;
	#if DEBUG > 1
				g_debug("VRML1: updating material of face #%d", faceidx);
	#endif
			}
		}
		faceidx ++;
	}
}
	YY_BREAK
case 15:
/* rule 15 can match eol */
YY_RULE_SETUP
#line 325 "imp_vrml_v1.l"
{
	if(otype == VRML_OTYPE_MTRANS_MATRIX)
	{
		if(sscanf(yytext, "%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f",
			&matrix[0 * 4 + 0],
			&matrix[0 * 4 + 1],
			&matrix[0 * 4 + 2],
			&matrix[0 * 4 + 3],

			&matrix[1 * 4 + 0],
            &matrix[1 * 4 + 1],
            &matrix[1 * 4 + 2],
            &matrix[1 * 4 + 3],

			&matrix[2 * 4 + 0],
            &matrix[2 * 4 + 1],
            &matrix[2 * 4 + 2],
            &matrix[2 * 4 + 3],

			&matrix[3 * 4 + 0],
            &matrix[3 * 4 + 1],
            &matrix[3 * 4 + 2],
            &matrix[3 * 4 + 3]) != 16)
		{
			g_warning("VRML: failed to read matrix line (%s)", yytext);
		}
	}
}
	YY_BREAK
case 16:
/* rule 16 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 12;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 354 "imp_vrml_v1.l"
{
	otype = VRML_OTYPE_MAT_AMBIENTCOLOR;
}
	YY_BREAK
case 17:
/* rule 17 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 12;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 358 "imp_vrml_v1.l"
{
	otype = VRML_OTYPE_MAT_DIFFUSECOLOR;
}
	YY_BREAK
case 18:
/* rule 18 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 13;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 362 "imp_vrml_v1.l"
{
	otype = VRML_OTYPE_MAT_SPECULARCOLOR;
}
	YY_BREAK
case 19:
/* rule 19 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 13;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 366 "imp_vrml_v1.l"
{
	otype = VRML_OTYPE_MAT_EMISSIVECOLOR;
}
	YY_BREAK
case 20:
/* rule 20 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 9;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 370 "imp_vrml_v1.l"
{
	otype = VRML_OTYPE_MAT_SHININESS;
}
	YY_BREAK
case 21:
/* rule 21 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 12;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 374 "imp_vrml_v1.l"
{
	otype = VRML_OTYPE_MAT_TRANSPARENCY;
}
	YY_BREAK
case 22:
/* rule 22 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 5;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 378 "imp_vrml_v1.l"
{
	otype = VRML_OTYPE_COORD3_POINT;
}
	YY_BREAK
case 23:
/* rule 23 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 10;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 382 "imp_vrml_v1.l"
{
	if(otype == VRML_OTYPE_IDXFACESET)
		otype = VRML_OTYPE_IDXFACESET_COORDIDX;
}
	YY_BREAK
case 24:
/* rule 24 can match eol */
*yy_cp = yyg->yy_hold_char; /* undo effects of setting up yytext */
yyg->yy_c_buf_p = yy_cp = yy_bp + 13;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 387 "imp_vrml_v1.l"
{
	#if DEBUG > 0
	g_debug("VRML1: materialIndex");
	#endif
	/*if(otype == VRML_OTYPE_IDXFACESET)*/
		otype = VRML_OTYPE_IDXFACESET_MATIDX;
}
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 395 "imp_vrml_v1.l"
{
	if(otype == VRML_OTYPE_MTRANS)
	{
		otype = VRML_OTYPE_MTRANS_MATRIX;
		ohasmtrx = 1;
	}
}
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 403 "imp_vrml_v1.l"
{
	/* set to parent object */
	otype &= 0xFF00;
	matidx = 0;
	faceidx = 0;
}
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 410 "imp_vrml_v1.l"
{
	vrml_dump_hier(level, yytext);
}
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 414 "imp_vrml_v1.l"
{
	level ++;
}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 418 "imp_vrml_v1.l"
{
	#if DEBUG > 3
	g_debug("}");
	#endif
	level --;

	if(material)
		material = NULL;

	if(object && (sep_level == level))
	{
		object = NULL;
	}

	/* reset object type */
	otype = 0x0000;
}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 436 "imp_vrml_v1.l"
/* */
	YY_BREAK
case 31:
/* rule 31 can match eol */
YY_RULE_SETUP
#line 437 "imp_vrml_v1.l"
/* */
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(VRMLHEADER):
case YY_STATE_EOF(COMMENT):
#line 439 "imp_vrml_v1.l"
{
	yyterminate();
}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 443 "imp_vrml_v1.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 1655 "imp_vrml_v1.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yyg->yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yyg->yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * vrml_v1_yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yyg->yy_c_buf_p <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yyg->yy_c_buf_p = yyg->yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state( yyscanner );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state , yyscanner);

			yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yyg->yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yyg->yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer( yyscanner ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yyg->yy_did_buffer_switch_on_eof = 0;

				if ( vrml_v1_yywrap(yyscanner ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yyg->yy_c_buf_p = yyg->yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yyg->yy_c_buf_p =
					yyg->yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yyg->yy_c_buf_p =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars];

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of vrml_v1_yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = yyg->yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yyg->yy_c_buf_p > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yyg->yy_c_buf_p - yyg->yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yyg->yy_c_buf_p - yyg->yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			yyg->yy_n_chars, (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	if ( yyg->yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			vrml_v1_yyrestart(yyin  ,yyscanner);
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) (yyg->yy_n_chars + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = yyg->yy_n_chars + number_to_move + (yyg->yy_n_chars >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) vrml_v1_yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size ,yyscanner );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	yyg->yy_n_chars += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yyg->yytext_ptr = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (yyscan_t yyscanner)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	yy_current_state = yyg->yy_start;
	yy_current_state += YY_AT_BOL();

	yyg->yy_state_ptr = yyg->yy_state_buf;
	*yyg->yy_state_ptr++ = yy_current_state;

	for ( yy_cp = yyg->yytext_ptr + YY_MORE_ADJ; yy_cp < yyg->yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 275 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		*yyg->yy_state_ptr++ = yy_current_state;
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state , yyscan_t yyscanner)
{
	register int yy_is_jam;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner; /* This var may be unused depending upon options. */

	register YY_CHAR yy_c = 1;
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 275 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 274);
	if ( ! yy_is_jam )
		*yyg->yy_state_ptr++ = yy_current_state;

	return yy_is_jam ? 0 : yy_current_state;
}

    static void yyunput (int c, register char * yy_bp , yyscan_t yyscanner)
{
	register char *yy_cp;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

    yy_cp = yyg->yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yyg->yy_hold_char;

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yyg->yy_n_chars + 2;
		register char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		register char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

	yyg->yytext_ptr = yy_bp;
	yyg->yy_hold_char = *yy_cp;
	yyg->yy_c_buf_p = yy_cp;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (yyscan_t yyscanner)
#else
    static int input  (yyscan_t yyscanner)
#endif

{
	int c;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	*yyg->yy_c_buf_p = yyg->yy_hold_char;

	if ( *yyg->yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yyg->yy_c_buf_p < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			/* This was really a NUL. */
			*yyg->yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yyg->yy_c_buf_p - yyg->yytext_ptr;
			++yyg->yy_c_buf_p;

			switch ( yy_get_next_buffer( yyscanner ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					vrml_v1_yyrestart(yyin ,yyscanner);

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( vrml_v1_yywrap(yyscanner ) )
						return EOF;

					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput(yyscanner);
#else
					return input(yyscanner);
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yyg->yy_c_buf_p = yyg->yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yyg->yy_c_buf_p;	/* cast for 8-bit char's */
	*yyg->yy_c_buf_p = '\0';	/* preserve yytext */
	yyg->yy_hold_char = *++yyg->yy_c_buf_p;

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * @param yyscanner The scanner object.
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void vrml_v1_yyrestart  (FILE * input_file , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! YY_CURRENT_BUFFER ){
        vrml_v1_yyensure_buffer_stack (yyscanner);
		YY_CURRENT_BUFFER_LVALUE =
            vrml_v1_yy_create_buffer(yyin,YY_BUF_SIZE ,yyscanner);
	}

	vrml_v1_yy_init_buffer(YY_CURRENT_BUFFER,input_file ,yyscanner);
	vrml_v1_yy_load_buffer_state(yyscanner );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * @param yyscanner The scanner object.
 */
    void vrml_v1_yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	/* TODO. We should be able to replace this entire function body
	 * with
	 *		vrml_v1_yypop_buffer_state();
	 *		vrml_v1_yypush_buffer_state(new_buffer);
     */
	vrml_v1_yyensure_buffer_stack (yyscanner);
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	vrml_v1_yy_load_buffer_state(yyscanner );

	/* We don't actually know whether we did this switch during
	 * EOF (vrml_v1_yywrap()) processing, but the only time this flag
	 * is looked at is after vrml_v1_yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yyg->yy_did_buffer_switch_on_eof = 1;
}

static void vrml_v1_yy_load_buffer_state  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	yyg->yytext_ptr = yyg->yy_c_buf_p = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	yyg->yy_hold_char = *yyg->yy_c_buf_p;
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * @param yyscanner The scanner object.
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE vrml_v1_yy_create_buffer  (FILE * file, int  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) vrml_v1_yyalloc(sizeof( struct yy_buffer_state ) ,yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in vrml_v1_yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) vrml_v1_yyalloc(b->yy_buf_size + 2 ,yyscanner );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in vrml_v1_yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	vrml_v1_yy_init_buffer(b,file ,yyscanner);

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with vrml_v1_yy_create_buffer()
 * @param yyscanner The scanner object.
 */
    void vrml_v1_yy_delete_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		vrml_v1_yyfree((void *) b->yy_ch_buf ,yyscanner );

	vrml_v1_yyfree((void *) b ,yyscanner );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a vrml_v1_yyrestart() or at EOF.
 */
    static void vrml_v1_yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file , yyscan_t yyscanner)

{
	int oerrno = errno;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	vrml_v1_yy_flush_buffer(b ,yyscanner);

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then vrml_v1_yy_init_buffer was _probably_
     * called from vrml_v1_yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * @param yyscanner The scanner object.
 */
    void vrml_v1_yy_flush_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		vrml_v1_yy_load_buffer_state(yyscanner );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  @param yyscanner The scanner object.
 */
void vrml_v1_yypush_buffer_state (YY_BUFFER_STATE new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (new_buffer == NULL)
		return;

	vrml_v1_yyensure_buffer_stack(yyscanner);

	/* This block is copied from vrml_v1_yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		yyg->yy_buffer_stack_top++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from vrml_v1_yy_switch_to_buffer. */
	vrml_v1_yy_load_buffer_state(yyscanner );
	yyg->yy_did_buffer_switch_on_eof = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  @param yyscanner The scanner object.
 */
void vrml_v1_yypop_buffer_state (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (!YY_CURRENT_BUFFER)
		return;

	vrml_v1_yy_delete_buffer(YY_CURRENT_BUFFER ,yyscanner);
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if (yyg->yy_buffer_stack_top > 0)
		--yyg->yy_buffer_stack_top;

	if (YY_CURRENT_BUFFER) {
		vrml_v1_yy_load_buffer_state(yyscanner );
		yyg->yy_did_buffer_switch_on_eof = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void vrml_v1_yyensure_buffer_stack (yyscan_t yyscanner)
{
	int num_to_alloc;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if (!yyg->yy_buffer_stack) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		yyg->yy_buffer_stack = (struct yy_buffer_state**)vrml_v1_yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in vrml_v1_yyensure_buffer_stack()" );
								  
		memset(yyg->yy_buffer_stack, 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		yyg->yy_buffer_stack_max = num_to_alloc;
		yyg->yy_buffer_stack_top = 0;
		return;
	}

	if (yyg->yy_buffer_stack_top >= (yyg->yy_buffer_stack_max) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = yyg->yy_buffer_stack_max + grow_size;
		yyg->yy_buffer_stack = (struct yy_buffer_state**)vrml_v1_yyrealloc
								(yyg->yy_buffer_stack,
								num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in vrml_v1_yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset(yyg->yy_buffer_stack + yyg->yy_buffer_stack_max, 0, grow_size * sizeof(struct yy_buffer_state*));
		yyg->yy_buffer_stack_max = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE vrml_v1_yy_scan_buffer  (char * base, yy_size_t  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) vrml_v1_yyalloc(sizeof( struct yy_buffer_state ) ,yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in vrml_v1_yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	vrml_v1_yy_switch_to_buffer(b ,yyscanner );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to vrml_v1_yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       vrml_v1_yy_scan_bytes() instead.
 */
YY_BUFFER_STATE vrml_v1_yy_scan_string (yyconst char * yystr , yyscan_t yyscanner)
{
    
	return vrml_v1_yy_scan_bytes(yystr,strlen(yystr) ,yyscanner);
}

/** Setup the input buffer state to scan the given bytes. The next call to vrml_v1_yylex() will
 * scan from a @e copy of @a bytes.
 * @param bytes the byte buffer to scan
 * @param len the number of bytes in the buffer pointed to by @a bytes.
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE vrml_v1_yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) vrml_v1_yyalloc(n ,yyscanner );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in vrml_v1_yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = vrml_v1_yy_scan_buffer(buf,n ,yyscanner);
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in vrml_v1_yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg , yyscan_t yyscanner)
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = yyg->yy_hold_char; \
		yyg->yy_c_buf_p = yytext + yyless_macro_arg; \
		yyg->yy_hold_char = *yyg->yy_c_buf_p; \
		*yyg->yy_c_buf_p = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the user-defined data for this scanner.
 * @param yyscanner The scanner object.
 */
YY_EXTRA_TYPE vrml_v1_yyget_extra  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyextra;
}

/** Get the current line number.
 * @param yyscanner The scanner object.
 */
int vrml_v1_yyget_lineno  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    
        if (! YY_CURRENT_BUFFER)
            return 0;
    
    return yylineno;
}

/** Get the current column number.
 * @param yyscanner The scanner object.
 */
int vrml_v1_yyget_column  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    
        if (! YY_CURRENT_BUFFER)
            return 0;
    
    return yycolumn;
}

/** Get the input stream.
 * @param yyscanner The scanner object.
 */
FILE *vrml_v1_yyget_in  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyin;
}

/** Get the output stream.
 * @param yyscanner The scanner object.
 */
FILE *vrml_v1_yyget_out  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyout;
}

/** Get the length of the current token.
 * @param yyscanner The scanner object.
 */
int vrml_v1_yyget_leng  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyleng;
}

/** Get the current token.
 * @param yyscanner The scanner object.
 */

char *vrml_v1_yyget_text  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yytext;
}

/** Set the user-defined data. This data is never touched by the scanner.
 * @param user_defined The data to be associated with this scanner.
 * @param yyscanner The scanner object.
 */
void vrml_v1_yyset_extra (YY_EXTRA_TYPE  user_defined , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyextra = user_defined ;
}

/** Set the current line number.
 * @param line_number
 * @param yyscanner The scanner object.
 */
void vrml_v1_yyset_lineno (int  line_number , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        /* lineno is only valid if an input buffer exists. */
        if (! YY_CURRENT_BUFFER )
           yy_fatal_error( "vrml_v1_yyset_lineno called with no buffer" , yyscanner); 
    
    yylineno = line_number;
}

/** Set the current column.
 * @param line_number
 * @param yyscanner The scanner object.
 */
void vrml_v1_yyset_column (int  column_no , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        /* column is only valid if an input buffer exists. */
        if (! YY_CURRENT_BUFFER )
           yy_fatal_error( "vrml_v1_yyset_column called with no buffer" , yyscanner); 
    
    yycolumn = column_no;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * @param yyscanner The scanner object.
 * @see vrml_v1_yy_switch_to_buffer
 */
void vrml_v1_yyset_in (FILE *  in_str , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyin = in_str ;
}

void vrml_v1_yyset_out (FILE *  out_str , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyout = out_str ;
}

int vrml_v1_yyget_debug  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yy_flex_debug;
}

void vrml_v1_yyset_debug (int  bdebug , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yy_flex_debug = bdebug ;
}

/* Accessor methods for yylval and yylloc */

/* User-visible API */

/* vrml_v1_yylex_init is special because it creates the scanner itself, so it is
 * the ONLY reentrant function that doesn't take the scanner as the last argument.
 * That's why we explicitly handle the declaration, instead of using our macros.
 */

int vrml_v1_yylex_init(yyscan_t* ptr_yy_globals)

{
    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }

    *ptr_yy_globals = (yyscan_t) vrml_v1_yyalloc ( sizeof( struct yyguts_t ), NULL );

    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }

    /* By setting to 0xAA, we expose bugs in yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));

    return yy_init_globals ( *ptr_yy_globals );
}

/* vrml_v1_yylex_init_extra has the same functionality as vrml_v1_yylex_init, but follows the
 * convention of taking the scanner as the last argument. Note however, that
 * this is a *pointer* to a scanner, as it will be allocated by this call (and
 * is the reason, too, why this function also must handle its own declaration).
 * The user defined value in the first argument will be available to vrml_v1_yyalloc in
 * the yyextra field.
 */

int vrml_v1_yylex_init_extra(YY_EXTRA_TYPE yy_user_defined,yyscan_t* ptr_yy_globals )

{
    struct yyguts_t dummy_yyguts;

    vrml_v1_yyset_extra (yy_user_defined, &dummy_yyguts);

    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }
	
    *ptr_yy_globals = (yyscan_t) vrml_v1_yyalloc ( sizeof( struct yyguts_t ), &dummy_yyguts );
	
    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }
    
    /* By setting to 0xAA, we expose bugs in
    yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));
    
    vrml_v1_yyset_extra (yy_user_defined, *ptr_yy_globals);
    
    return yy_init_globals ( *ptr_yy_globals );
}

static int yy_init_globals (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from vrml_v1_yylex_destroy(), so don't allocate here.
     */

    yyg->yy_buffer_stack = 0;
    yyg->yy_buffer_stack_top = 0;
    yyg->yy_buffer_stack_max = 0;
    yyg->yy_c_buf_p = (char *) 0;
    yyg->yy_init = 0;
    yyg->yy_start = 0;

    yyg->yy_start_stack_ptr = 0;
    yyg->yy_start_stack_depth = 0;
    yyg->yy_start_stack =  NULL;

    yyg->yy_state_buf = 0;
    yyg->yy_state_ptr = 0;
    yyg->yy_full_match = 0;
    yyg->yy_lp = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * vrml_v1_yylex_init()
     */
    return 0;
}

/* vrml_v1_yylex_destroy is for both reentrant and non-reentrant scanners. */
int vrml_v1_yylex_destroy  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		vrml_v1_yy_delete_buffer(YY_CURRENT_BUFFER ,yyscanner );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		vrml_v1_yypop_buffer_state(yyscanner);
	}

	/* Destroy the stack itself. */
	vrml_v1_yyfree(yyg->yy_buffer_stack ,yyscanner);
	yyg->yy_buffer_stack = NULL;

    /* Destroy the start condition stack. */
        vrml_v1_yyfree(yyg->yy_start_stack ,yyscanner );
        yyg->yy_start_stack = NULL;

    vrml_v1_yyfree ( yyg->yy_state_buf , yyscanner);
    yyg->yy_state_buf  = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * vrml_v1_yylex() is called, initialization will occur. */
    yy_init_globals( yyscanner);

    /* Destroy the main struct (reentrant only). */
    vrml_v1_yyfree ( yyscanner , yyscanner );
    yyscanner = NULL;
    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n , yyscan_t yyscanner)
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s , yyscan_t yyscanner)
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *vrml_v1_yyalloc (yy_size_t  size , yyscan_t yyscanner)
{
	return (void *) malloc( size );
}

void *vrml_v1_yyrealloc  (void * ptr, yy_size_t  size , yyscan_t yyscanner)
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void vrml_v1_yyfree (void * ptr , yyscan_t yyscanner)
{
	free( (char *) ptr );	/* see vrml_v1_yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 443 "imp_vrml_v1.l"




